import processing.video.*;
Capture video;

float[] bright;

void setup() {
  size(640, 360);
  noStroke();
  
  video = new Capture(this, 64, 48);
    video.start();
    
  int count = (video.width) * (video.height);  
  bright = new float[count];
  for (int i = 0; i < count; i++) {
    // set each brightness at the midpoint to start
    bright[i] = 10;
  }
}

void captureEvent(Capture c) {
  c.read();
}

void draw() {
  
  int index = 0;
  
  video.loadPixels();
    
  background(0);
  
  
for(int i = 0; i<height; i+=10){
  

for(int j = 0; j<width; j+=10){
  
      int pixelColor = video.pixels[index];
      // Faster method of calculating r, g, b than red(), green(), blue() 
      int r = (pixelColor >> 16) & 0xff;
      int g = (pixelColor >> 8) & 0xff;
      int b = pixelColor & 0xff;

      // Another option would be to properly calculate brightness as luminance:
      // luminance = 0.3*red + 0.59*green + 0.11*blue
      // Or you could instead red + green + blue, and make the the values[] array
      // 256*3 elements long instead of just 256.
      int pixelBright = max(r, g, b);

      // The 0.1 value is used to damp the changes so that letters flicker less
      float diff = pixelBright - bright[index];
      bright[index] += diff * 0.1;

      //fill();
  
  
  fill(pixelColor);
  
    int yop = int(bright[index]);
    yop = (int)map(yop,0,255,0,20);
    //println(yop);
    
    ellipse(j,i,yop,yop);
    //ellipse(j,i,10,10);

   index++; 
}


}  


}